//////////////////////////////////////////////////
///////////////////Water Tools////////////////////
//////////////////////////////////////////////////
////03.04.2008////////////////by Nils Daumann/////
/////////////slindev.wordpress.com////////////////
//////////////////////////////////////////////////
#ifndef OS_Tools_WriteTGA_
	#include "OS_Tools_WriteTGA.c"
#endif


//returns the unique name of the blendmap for the entity
STRING* OS_Water_Tools_GetBlendMapName(ENTITY* Ent)
{
	STRING* Temp_str = str_create("#100");
	str_for_entname(Temp_str,Ent);
	str_cat(Temp_str,"_");
	str_cat(Temp_str,level_name);
	str_trunc(Temp_str,4);
	str_cat(Temp_str,".tga");
	return Temp_str;
}

//generates the blendmap (this can take a several minutes with a high resolution!)
void OS_Water_Tools_CreateBlendMap(ENTITY* Ent, int SizeX, int SizeY, var ShoreDepth)
{
	var px;
	var py;
	var format;
	var pixel;
	float Dist;
	var temp[3];
	
	BMAP* canvas;
	var canvas_size[2];
	var pixel_size[2];

	canvas = bmap_createblack(SizeX,SizeY,24);
	canvas_size[0] = bmap_width(canvas);
	canvas_size[1] = bmap_height(canvas);

	py = 0;
	while(py < canvas_size[1])
	{
		px = 0;
		while(px < canvas_size[0])
		{
			// get the world coordinates of the pixel
			pixel_size[0] = (Ent.max_x-Ent.min_x)/canvas_size[0];
			pixel_size[1] = (Ent.max_y-Ent.min_y)/canvas_size[1];
			temp[0] = ((Ent.x-Ent.min_x)-(pixel_size[0]*px))-pixel_size[0]/2;
			temp[1] = ((Ent.y-Ent.min_y)-(pixel_size[1]*py))-pixel_size[1]/2;
			c_trace(vector(temp[0],temp[1],Ent.z+50000),vector(temp[0],temp[1],Ent.z-50000),IGNORE_MODELS|IGNORE_SPRITES|IGNORE_MAPS);
			temp[2] = target.z;
			
			Dist = c_trace(vector(temp[0],temp[1],Ent.z),vector(temp[0],temp[1],Ent.z-10000),IGNORE_ME|IGNORE_SPRITES|IGNORE_MODELS|USE_POLYGON);
			
			format = bmap_lock(canvas,0);
			pixel = pixel_for_vec(vector(0,0,clamp((Dist/(ShoreDepth))*255,0,255)),100,format);
			pixel_to_bmap(canvas,(canvas_size[0]-1)-px,py,pixel);
			bmap_unlock(canvas);
			
			px += 1;
		}
		py += 1;
	}
	
	beep();
	OS_Tools_WriteTGA(OS_Water_Tools_GetBlendMapName(Ent),canvas);
	beep();
}

//returns the pointer to the blendmap for the entity
BMAP* OS_Water_Tools_LoadBlendMap(ENTITY* Ent)
{
	return bmap_create(OS_Water_Tools_GetBlendMapName(Ent));
}