//////////////////////////////////////////////////
/////////////////Stereo Anaglyph//////////////////
//////////////////////////////////////////////////
////14.03.2008////////////////by Nils Daumann/////
/////////////slindev.wordpress.com////////////////
//////////////////////////////////////////////////
#define PP_Anaglyph


VIEW* PP_Anaglyph_view;
var PP_Anaglyph_EyeDist;

//PS 1.4 shader to combine the two views with the right coloring for the filters
MATERIAL* PP_Anaglyph_Combine_mat=
{
	effect =
	"
		float4 vecViewPort;
		
		texture TargetMap;
		texture mtlSkin1;
		sampler smpTarget = sampler_state { Texture = <TargetMap>; };
		sampler smpSkin1 = sampler_state { Texture = <mtlSkin1>; };
		
		//Echte Anaglyphen
/*		float4x4 matView1ColTrans =
		{
			0.299,	0.587,	0.114,	0.0,
			0.0,		0.0,		0.0,		0.0,
			0.0,		0.0,		0.0,		0.0,
			0.0,		0.0,		0.0,		1.0
		};
		
		float4x4 matView2ColTrans =
		{
			0.0,		0.0,		0.0,		0.0,
			0.0,		0.0,		0.0,		0.0,
			0.299,	0.587,	0.114,	0.0,
			0.0,		0.0,		0.0,		1.0
		};*/
		
		//Graue Anaglyphen:
/*		float4x4 matView1ColTrans =
		{
			0.299,	0.587,	0.114,	0.0,
			0.0,		0.0,		0.0,		0.0,
			0.0,		0.0,		0.0,		0.0,
			0.0,		0.0,		0.0,		1.0
		};
		
		float4x4 matView2ColTrans =
		{
			0.0,		0.0,		0.0,		0.0,
			0.299,	0.587,	0.114,	0.0,
			0.299,	0.587,	0.114,	0.0,
			0.0,		0.0,		0.0,		1.0
		};*/
		
		//Farbige Anaglyphen:
		float4x4 matView1ColTrans =
		{
			1.0,		0.0,		0.0,		0.0,
			0.0,		0.0,		0.0,		0.0,
			0.0,		0.0,		0.0,		0.0,
			0.0,		0.0,		0.0,		1.0
		};
		
		float4x4 matView2ColTrans =
		{
			0.0,		0.0,		0.0,		0.0,
			0.0,		1.0,		0.0,		0.0,
			0.0,		0.0,		1.0,		0.0,
			0.0,		0.0,		0.0,		1.0
		};
		
		//Halbfarbige Anaglyphen:
/*		float4x4 matView1ColTrans =
		{
			0.299,	0.587,	0.114,	0.0,
			0.0,		0.0,		0.0,		0.0,
			0.0,		0.0,		0.0,		0.0,
			0.0,		0.0,		0.0,		1.0
		};
		
		float4x4 matView2ColTrans =
		{
			0.0,		0.0,		0.0,		0.0,
			0.0,		1.0,		0.0,		0.0,
			0.0,		0.0,		1.0,		0.0,
			0.0,		0.0,		0.0,		1.0
		};*/
		
/*		//Optimierte Anaglyphen:
		float4x4 matView1ColTrans =
		{
			0.0,		0.7,		0.3,		0.0,
			0.0,		0.0,		0.0,		0.0,
			0.0,		0.0,		0.0,		0.0,
			0.0,		0.0,		0.0,		1.0
		};
		
		float4x4 matView2ColTrans =
		{
			0.0,		0.0,		0.0,		0.0,
			0.0,		1.0,		0.0,		0.0,
			0.0,		0.0,		1.0,		0.0,
			0.0,		0.0,		0.0,		1.0
		};*/
		
		//Amber-Blue:
/*		float4x4 matView1ColTrans =
		{
			0.0,		0.0,		0.0,		0.0,
			0.0,		0.0,		0.0,		0.0,
			0.299,	0.587,	0.114,	0.0,
			0.0,		0.0,		0.0,		1.0
		};
		
		float4x4 matView2ColTrans =
		{
			1.0,		0.0,		0.0,		0.0,
			0.0,		1.0,		0.0,		0.0,
			0.0,		0.0,		0.0,		0.0,
			0.0,		0.0,		0.0,		1.0
		};*/
		
		float4 PixeShader(float2 TexCoords : TEXCOORD0) :COLOR
		{
			float4 ColorView1 = tex2D(smpTarget,TexCoords);
			float4 ColorView2 = tex2D(smpSkin1,TexCoords);
			
			float4 Color = mul(matView1ColTrans,ColorView1)+mul(matView2ColTrans,ColorView2);

			return Color;
		}
		
		technique PPE
		{
			pass p1
			{
				PixelShader = compile ps_2_0 PixeShader();
			}
		}
	";
}

//function to change the values for the anaglyphs
void PP_Anaglyph_SetValues(var EyeDist)
{
	PP_Anaglyph_EyeDist = EyeDist;
}

void PP_Anaglyph_init(VIEW* View, var EyeDist)
{
	if(d3d_shaderversion >= 2020)
	{
		if(PP_Anaglyph_view == NULL)
		{
			PP_Anaglyph_view = view_create(-1);
		}
		set(PP_Anaglyph_view,VISIBLE);
		
		PP_Anaglyph_view.size_x = screen_size.x;
		PP_Anaglyph_view.size_y = screen_size.y;
	
		if(PP_Anaglyph_Combine_mat.skin1 == NULL){PP_Anaglyph_Combine_mat.skin1 = bmap_createblack(screen_size.x,screen_size.y,24);}
		PP_Anaglyph_view.bmap = PP_Anaglyph_Combine_mat.skin1;
		
		PP_Anaglyph_SetValues(EyeDist);
		
		PP_Add(PP_Anaglyph_Combine_mat,View,NULL);
		
		proc_mode = PROC_LATE;
		while(View != NULL && PP_Anaglyph_view != NULL)
		{
			PP_Anaglyph_view.arc = View.arc;
			
			PP_Anaglyph_view.z = View.z;
			PP_Anaglyph_view.y = View.y - PP_Anaglyph_EyeDist*cos(View.pan);
			PP_Anaglyph_view.x = View.x + PP_Anaglyph_EyeDist*sin(View.pan);
			vec_set(PP_Anaglyph_view.pan,View.pan);
			PP_Anaglyph_view.arc = View.arc;
			PP_Anaglyph_view.aspect = View.aspect;
			
			wait(1);
		}
	}
}


//removes Anaglyph
void PP_Anaglyph_remove(VIEW* View)
{
	//remove the view
	PP_Anaglyph_view.bmap = NULL;
	reset(PP_Anaglyph_view,VISIBLE);
	ptr_remove(PP_Anaglyph_view);
	PP_Anaglyph_view = NULL;
	
	//remove the stage
	PP_Remove(PP_Anaglyph_Combine_mat,View,NULL);
	
	//remove the bmap
	ptr_remove(PP_Anaglyph_Combine_mat.skin1);
	PP_Anaglyph_Combine_mat.skin1 = NULL;
}

//makes it fit to the new resolution
void PP_Anaglyph_Video_Switch(VIEW* View)
{
	//if Anaglyph is active
	if(is(PP_Anaglyph_view,VISIBLE))
	{
		//remove the effect
		PP_Anaglyph_remove(View);
		
		//and create it again:
		
		if(PP_Anaglyph_view == NULL)
		{
			PP_Anaglyph_view = view_create(-1);
		}
		set(PP_Anaglyph_view,VISIBLE);
		
		PP_Anaglyph_view.size_x = screen_size.x;
		PP_Anaglyph_view.size_y = screen_size.y;
	
		if(PP_Anaglyph_Combine_mat.skin1 == NULL){PP_Anaglyph_Combine_mat.skin1 = bmap_createblack(screen_size.x,screen_size.y,24);}
		PP_Anaglyph_view.bmap = PP_Anaglyph_Combine_mat.skin1;
		
		PP_Add(PP_Anaglyph_Combine_mat,View,NULL);
	}
}