//////////////////////////////////////////////////
///////////Postprocessing Color Filter////////////
//////////////////////////////////////////////////
////09.04.2008////////////////by Nils Daumann/////
/////////////slindev.wordpress.com////////////////
//////////////////////////////////////////////////
#define PP_ColorFiler


//transforms the colors with the material matrix
MATERIAL* PP_ColorFiler_mat =
{
	effect =
	"
		//Variables
		float4x4 matMtl;
		
		//Texture
		texture TargetMap;
		sampler2D ColorSampler = sampler_state { texture = <TargetMap>;};
		
		//Pixelshader
		float4 PS( float2 texCoord : TEXCOORD0 ) : COLOR0 
		{
			float4 Color = tex2D(ColorSampler,texCoord);
			Color = mul(matMtl,Color);
			return Color;
		}
		
		technique Tech1
		{
			pass one
			{
				PixelShader = compile ps_2_0 PS();
			}
		}
	";
}

//adjust the matrix values
void PP_ColorFiler_SetValues(	var m11, var m12, var m13,
										var m21, var m22, var m23,
										var m31, var m32, var m33)
{
	mat_identity(PP_ColorFiler_mat.matrix);
	PP_ColorFiler_mat.matrix11 = m11;
	PP_ColorFiler_mat.matrix12 = m12;
	PP_ColorFiler_mat.matrix13 = m13;
	PP_ColorFiler_mat.matrix21 = m21;
	PP_ColorFiler_mat.matrix22 = m22;
	PP_ColorFiler_mat.matrix23 = m23;
	PP_ColorFiler_mat.matrix31 = m31;
	PP_ColorFiler_mat.matrix32 = m32;
	PP_ColorFiler_mat.matrix33 = m33;
}

//starts the effect
void PP_ColorFiler_init(VIEW* View, var m11, var m12, var m13,
												var m21, var m22, var m23,
												var m31, var m32, var m33)
{
	if(d3d_shaderversion >= 2020)
	{
		//pass the values to the material
		PP_ColorFiler_SetValues(m11,m12,m13,m21,m22,m23,m31,m32,m33);
		
		//add the effect as a next stage
		PP_Add(PP_ColorFiler_mat,View,NULL);
	}
}

//removes ColorFiler
void PP_ColorFiler_remove(VIEW* View)
{
	//remove the stage
	PP_Remove(PP_ColorFiler_mat,View,NULL);
}